/**********************************************************************
*       FILE:   control.c
*       AUTHOR: Evan H. Bynum
*       DATE:   1 May, 1993
*       PURPOSE: To play the game!
**********************************************************************/

#include "keybd.h"
#include "ui.h"
#include "players.h"
#include "map.h"
#include "rules.h"
#include "ufwoom.h"
#include <assert.h>
#include <stdio.h>
#include <conio.h>


Video 	Screen (VGAHi);
MSMouse Mouse (Graphics);
Keybd 	Keys;

Player *thePlayers [MAXPLAYERS];
int    	NumPlayers;

Display 	theDisplay;
Map 		theMap;
UserInterface 	UI;
Rules 		theRules;


void PlayerSetup (void)
  {
   int *info, counter, nextPlayer;

   info = UI.UFWOOM ();
   if ((*info) == ComputerP)
     *thePlayers = new ComputerSpy ("Mr. X", PColor [0]);
   else
     *thePlayers = new HumanSpy ("Mr. X", PColor [0]);

   nextPlayer = NumPlayers = 1;   // Need a spy; first detective = player #1
   for (counter = 1; counter < MAXPLAYERS; counter++)
   {
     char buf [40];
     sprintf (buf, "Detective %d", counter);
     switch (info [counter])
       {
	case ComputerP :
	  thePlayers [nextPlayer++] = new ComputerDetective (buf, PColor [counter]);
	  NumPlayers++;
	  break;
	case HumanP :
	  thePlayers [nextPlayer++] = new HumanDetective (buf, PColor [counter]);
	  NumPlayers++;
	  break;
       }
   }
   delete info;         // Big Brother is gonna fuck you up real bad
  }

void HosePlayers (void)
  {
    for (int i=0; i<NumPlayers; i++)
      delete thePlayers [i];
  }



main ()
  {
   assert (Mouse.SetupOK ());
   assert (theMap.load_map ("NODELIST"));    // Get filename from cmdline
   bool busted;         // Has the spy been caught?
   int counter;

   UI.Intro();

   PlayerSetup ();      // You figure it out, ya dumb fuck

   UI.InitScreen ();
   UI.ShowAllPlayers ();

   // Main game loop
   while (! (busted = (bool) theRules.GameOver ()))
     {
      // Move the Spy
      (*thePlayers) -> TakeTurn ();

      // Move the detectives
      for (counter = 1; (counter < NumPlayers) && (!busted); counter++)
	{
	 thePlayers [counter] -> TakeTurn ();
	 busted = (bool) theRules.SpyCaught ();
	}
      theRules.NewTurn ();
     }
   if (busted == -1)
     UI.AnnounceWin (*thePlayers[0], theRules.CurrentTurn());
   else
     UI.AnnounceWin (*thePlayers[busted], theRules.CurrentTurn());

//   HosePlayers ();      // Nuke the players; we don't need them anymore

   return 0;
  }
