/**********************************************************************
*	FILE:	intro.c
*	AUTHOR:	SRWinig
*	DATE:	1 May 1993
*	PURPOSE:
*	  Introduce the game and the writers
***********************************************************************/

#include "ui.h"
#include "button.h"
#include <dos.h>
#include <assert.h>
#include <graphics.h>

const int Pause = 100;

void UserInterface::AboutButton(Display& IntroDisplay)
{
  Window *wf1 = new Window (200, 80, GREEN, LIGHTGRAY);
  assert (wf1 != NULL);
  IntroDisplay.Add (wf1, 175, 20);
  IntroDisplay.Draw();
  wf1->Client().SetTextStyle (GOTHIC_FONT, 0, 3);
  wf1->Client().SetTextJustify (CENTER_TEXT, CENTER_TEXT);
  wf1->Client().OutTextXY (wf1->Client().GetMaxX()/2, wf1->Client().GetMaxY()/2, "PREGO");
  delay(Pause);
  Window *wf2 = new Window (200, 80, GREEN, LIGHTGRAY);
  assert (wf2 != NULL);
  IntroDisplay.Add (wf2, 5, 250);
  IntroDisplay.Draw();
  wf2->Client().SetTextStyle (GOTHIC_FONT, 0, 3);
  wf2->Client().SetTextJustify (CENTER_TEXT, CENTER_TEXT);
  wf2->Client().OutTextXY (wf2->Client().GetMaxX()/2, wf2->Client().GetMaxY()/2, "SOMBRERO");
  delay(Pause);
  Window *wf3 = new Window (200, 80, GREEN, LIGHTGRAY);
  assert (wf3 != NULL);
  IntroDisplay.Add (wf3, 350, 223);
  IntroDisplay.Draw();
  wf3->Client().SetTextStyle (GOTHIC_FONT, 0, 3);
  wf3->Client().SetTextJustify (CENTER_TEXT, CENTER_TEXT);
  wf3->Client().OutTextXY (wf3->Client().GetMaxX()/2, wf3->Client().GetMaxY()/2, "KNEE CAPS");
  delay (Pause);
  Window *wf4 = new Window (300, 50, BLUE, LIGHTGRAY);
  assert (wf4 != NULL);
  IntroDisplay.Add (wf4, 5, 400);
  IntroDisplay.Draw();
  wf4->Client().SetTextStyle (GOTHIC_FONT, 0, 2);
  wf4->Client().SetTextJustify (CENTER_TEXT, CENTER_TEXT);
  wf4->Client().OutTextXY (wf4->Client().GetMaxX()/2, wf4->Client().GetMaxY()/2, "Click anywhere to play game");
  delay (Pause/2);
}



void UserInterface::Intro()
{
  Display IntroDisplay;

  IntroDisplay.SetBkColor (BLACK);
  IntroDisplay.Clear();

  IntroDisplay.SetTextStyle (TRIPLEX_FONT, 0, 12);
  IntroDisplay.SetColor (LIGHTGRAY);
  IntroDisplay.SetTextJustify (CENTER_TEXT, CENTER_TEXT);
  IntroDisplay.OutTextXY (IntroDisplay.GetMaxX()/2, 90, "Scotland");
  IntroDisplay.SetColor (WHITE);
  IntroDisplay.OutTextXY (IntroDisplay.GetMaxX()/2 - 4, 86, "Scotland");
  IntroDisplay.SetTextStyle (TRIPLEX_FONT, 0, 14);
  IntroDisplay.SetColor (LIGHTGRAY);
  IntroDisplay.OutTextXY (IntroDisplay.GetMaxX()/2, 300, "Yard");
  IntroDisplay.SetColor (WHITE);
  IntroDisplay.OutTextXY (IntroDisplay.GetMaxX()/2 - 4, 296, "Yard");

//  delay(1500);

  Window *w2 = new Window (100, 80, BLUE, LIGHTGRAY);
  assert (w2 != NULL);
  IntroDisplay.Add (w2, 160, 180);
  IntroDisplay.Draw();
  w2->Client().SetTextStyle (GOTHIC_FONT, 0, 3);
  w2->Client().SetColor (BLUE);
  w2->Client().OutTextXY(18, 10, "Chris");
  w2->Client().OutTextXY(15, 30, "League");
  delay(Pause);

  Window *w4 = new Window (100, 80, BLUE, LIGHTGRAY);
  assert (w4 != NULL);
  IntroDisplay.Add (w4, 370, 180);
  IntroDisplay.Draw();
  w4->Client().SetTextStyle (GOTHIC_FONT, 0, 3);
  w4->Client().SetColor (BLUE);
  w4->Client().OutTextXY(20, 10, "Evan");
  w4->Client().OutTextXY(14, 30, "Owens");
  delay(Pause);

  Window *w3 = new Window (100, 80, BLUE, LIGHTGRAY);
  assert (w3 != NULL);
  IntroDisplay.Add (w3, 265, 180);
  IntroDisplay.Draw();
  w3->Client().SetTextStyle (GOTHIC_FONT, 0, 3);
  w3->Client().SetColor (BLUE);
  w3->Client().OutTextXY(15, 10, "Wilson");
  w3->Client().OutTextXY(20, 30, "Tham");
  delay(Pause);

  Window *w = new Window (100, 80, BLUE, LIGHTGRAY);
  assert (w != NULL);
  IntroDisplay.Add (w, 55, 180);
  IntroDisplay.Draw();
  w->Client().SetTextStyle (GOTHIC_FONT, 0, 3);
  w->Client().SetColor (BLUE);
  w->Client().OutTextXY(18, 10, "Steve");
  w->Client().OutTextXY(18, 30, "Winig");
  delay(Pause);

  Window *w5 = new Window (100, 80, BLUE, LIGHTGRAY);
  assert (w5 != NULL);
  IntroDisplay.Add (w5, 475, 180);
  IntroDisplay.Draw();
  w5->Client().SetTextStyle (GOTHIC_FONT, 0, 3);
  w5->Client().SetColor (BLUE);
  w5->Client().OutTextXY(20, 10, "Evan");
  w5->Client().OutTextXY(14, 30, "Bynum");

  PushButton *pb = new PushButton ("Play Game", BLUE, 0xFB);
  assert (pb != NULL);
  PushButton *pb2 = new PushButton ("About...", BLUE, 0xFA);
  assert (pb2 != NULL);
//  PushButton *pb3 = new PushButton ("Huh???", BLUE, 0xF0);
//  assert (pb3 != NULL);

  IntroDisplay.Add (pb, 500, IntroDisplay.GetMaxY() - pb->GetYDim() - 5);
  IntroDisplay.Add (pb2, 500 - pb->GetXDim() - 5, IntroDisplay.GetMaxY() - pb2->GetYDim() - 5);
//  IntroDisplay.Add (pb3, 500 - pb->GetXDim() - pb2->GetXDim() - 20, IntroDisplay.GetMaxY() - pb3->GetYDim() - 5);
  IntroDisplay.Draw();

  Message DoneMsg (ButtonMsg, ButtonPress, 0xFB),
	  AboutMsg (ButtonMsg, ButtonPress, 0xFA),
//	  Bounce (ButtonMsg, ButtonPress, 0xF0),
	  m;

  do {
    m = IntroDisplay.Dispatch (Mouse.Event());
    if (m == AboutMsg)
    { AboutButton(IntroDisplay);
      m = IntroDisplay.Dispatch (Mouse.WaitForAnyEvent());
      m = DoneMsg;
    }
//    if (m == Bounce)
//    {
//      for (int i = 0; i < 10; i++)
//      {
//
//
//      }
//    }
  } while (m != DoneMsg);
}