// ******************************************************************
// * TITLE: keywin.cpp                                              *
// * AUTHOR: Steven Winig                                           *
// * DATE: April 30, 1993                                           *
// * Purpose: Create display Key Window for main screen             *
// ******************************************************************

#include "window.h"
#include "keywin.h"
#include "checkbox.h"
#include "scrnobj.h"
#include "ui.h"

#include <alloc.h>
#include <assert.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <string.h>

KeyWindow::KeyWindow ()
{
  XDim = KeyXDim;  YDim = KeyYDim;
  CliX1 = CliY1 = CliX2 = CliY2 = 0;
  TX1 = TY1 = TX2 = TY2 = 0;
  BorderColor = RED;
  BkColor = LIGHTGRAY;
  TitleColor = WHITE;
  Title = new char [4];
  assert (Title != 0);
  strcpy (Title, "Legend");
  ClientD = TitleD = NULL;
  Drawn = False;
}

void KeyWindow::Init (Display *d, int x, int y)
{
  Disp = d;
  X = x;  Y = y;

  char buf[3];

  CalcBorder ();
  if (Title)
  {
    CalcTitle ();
    TitleD = new Display (Disp, TX1, TY1, TX2, TY2);
    assert (TitleD != 0);
    TitleD->SetBkColor (BorderColor);
    TitleD->SetTextJustify (CENTER_TEXT, TOP_TEXT);
    TitleD->SetTextStyle (TitleFont, HORIZ_DIR, TitleFontSize);
    TitleD->SetColor (TitleColor);
  }
  ClientD = new Display (Disp, CliX1, CliY1, CliX2, CliY2);
  assert (ClientD != 0);
  ClientD->SetBkColor (BkColor);
  // Add stuff to the window

  for (int i=0; i < MaxPlayers; i++) {
    if (i != 0)
      {sprintf (buf, "%d", i);}
    else
      {sprintf (buf, "X");}
    c[i] = new CheckBox(buf, BLACK, PColor[i], i, Circle);
    assert (c[i] != NULL);
  }
    ClientD->Add (c[0], 5, 0 ); // Since we know there are a max of 6 players
    ClientD->Add (c[1], 5, 20); // Don't bother incorporating this into the
    ClientD->Add (c[2], 5, 40); // above loop
    ClientD->Add (c[3], 35, 0);
    ClientD->Add (c[4], 35, 20);
    ClientD->Add (c[5], 35, 40);
}


void KeyWindow::Draw (void)
{
  if (!Drawn)
  {
    assert (Disp != NULL);
    Disp->FastDraw ();
    PrepScreen ();
    DrawBorder ();
    if (TitleD)
      DrawTitle ();
    ClientD->Clear ();
    ClientD->Draw ();
    Disp->Done ();
    Drawn = True;

    // Turn on all of the buttons and make sure they are static
    for (int i = 0; i < MaxPlayers; i++) {
      c[i] -> ChangeStatus (On);
      c[i] -> SetPseudo (Off); // since there are no messages this is redundant
    }
  }
}

