/*************************************************************************
 *
 * 	FILE:	mapwin.h
 *	AUTHOR:	Wilson Tham
 *	DATE:	30 April 1993
 *	PURPOSE:
 *
 **************************************************************************/

#ifndef _MAPWIN_H
#define _MAPWIN_H

#include "window.h"
#include "nodes.h"
#include "moves.h"

const int TransWidth=3;
const int MapWinXDim = 639;
const int MapWinYDim = 400;
const int TransColor[3]={14, 2, 4};

class MapWindow : public Window
{
	int NNodes;
	Nodes **NodeList;

public:
	MapWindow			(void);
	~MapWindow		(void);	// delete node list

	void Init			(Display*, int, int);
	void Draw			(void);
	void EnableNodes    (MoveList &, int);
	void DisableNodes	(MoveList &);
	void HilightNode	(int, int);
	void UnHilightNode	(int);

private:
	void AllocNodes	(void);
	void DrawLines		(void);
	void ConnectNode	(int node1, int node2);
	void Scale		(int& , int& );
	void NewConnectNode (int, int, byte);
};

#endif
