/*************************************************************************
* 	FILE:	popupwin.h
*	AUTHOR: CALeague
*	DATE:	25 April 1993
*	PURPOSE:
*	  Pop-up windows "memorize" the image which they overwrite when
*	  they are drawn, and restore the image when they are erased.
**************************************************************************/

#ifndef _POPUPWIN_H
#define _POPUPWIN_H

#include "window.h"


class PopUpWin : public Window
{
  void *buffer;
protected:
  PopUpWin (void) : Window () { buffer = NULL; }
public:
  PopUpWin (int dx, int dy, int bc, int bkc)
    : Window (dx, dy, bc, bkc) { buffer = NULL; }
  PopUpWin (int dx, int dy, int bc, int bkc, char* t, int tc)
    : Window (dx, dy, bc, bkc, t, tc) { buffer = NULL; }
  virtual ~PopUpWin () { Erase(); delete buffer; }
  virtual void PrepScreen (void);
  virtual void Erase (void);
};


#endif
