/**********************************************************************
*	FILE:	video.h
*	AUTHOR: CALeague
*	DATE:	17 April 1993
*	PURPOSE:
*	  Contains Video class to initialize the Borland Graphics
*	  Interface.
*	USAGE:
*	  A global instance should be declared as such:
*	    Video graphics (graphics_mode);
*	  where graphics_mode is one of the enumerated supported modes.
*	WARNING:
*	  If the BGI driver is linked, define the LINK_BGI directive.
*	  Otherwise, it will search for the proper .BGI file in the
*	  current directory.  If the font files are linked, define
*	  the LINK_FONT directive.  Otherwise, it will search for
*	  the proper .CHR files in the current directory durring
*	  runtime.
***********************************************************************/

#ifndef _VIDEO_H
#define _VIDEO_H

#include <graphics.h>

/**********************************************************************
*	Supported Modes
***********************************************************************/

enum VideoModes { VGAHi, Detect };


/**********************************************************************
*	Class Definition
***********************************************************************/

class Video
{
  VideoModes Mode;
public:
  Video (VideoModes mode);
  ~Video (void);
  int GetMaxX (void)  { return getmaxx (); }
  int GetMaxY (void)  { return getmaxy (); }
  int GetMaxColor (void)  { return getmaxcolor (); }
};

extern Video Screen;	// Global instance

#endif
